#!/usr/bin/env python
'''
This file contains Python command example for the RM module.
Python commands syntax is very similar to the Switch SDK APIs.
You can learn more about each command and its parameters by reading the SwitchX API Reference Manual.

This is a utility script that allows the user to dump the current resource utilization
in the SDK from both a Hardare and Logical resource perspective.
'''
import os
import sys

from python_sdk_api.sx_api import *

from test_infra_common import *
from sx_api_resource_manager_apis import *

print "[+] opening sdk"
rc, handle = sx_api_open(None)
print ("sx_api_open handle:0x%x , rc %d " % (handle, rc))
if (rc != SX_STATUS_SUCCESS):
    print "Failed to open api handle.\nPlease check that SDK is running."
    sys.exit(errno.EACCES)


######################################################
#    main
######################################################
def main():

    print ("\n\n HW Table Utilization\n\n")

    get_hw_utilization(handle, RM_HW_TABLE_TYPE_TCAM_E)
    get_hw_utilization(handle, RM_HW_TABLE_TYPE_KVD_HASH_E)
    get_hw_utilization(handle, RM_HW_TABLE_TYPE_KVD_LINEAR_E)
    get_hw_utilization(handle, RM_HW_TABLE_TYPE_PGT_E)
    get_hw_utilization(handle, RM_HW_TABLE_TYPE_FLOW_COUNTER_E)
    get_hw_utilization(handle, RM_HW_TABLE_TYPE_ACL_REGIONS_TABLE_E)

    print ("\n\nLogical Free Entries Count\n\n")
    get_logical_free_entries_count(handle, [])

    print ("\n\nLogical Table Utilization\n\n")
    get_logical_utilization(handle, [])


if __name__ == "__main__":
    main()


""" ############################################################################################ """
sx_api_close(handle)
""" ############################################################################################ """
